#include<iostream>

#include<cstdio> 
#include<string> 
#include <stdio.h>     

#include <math.h>  
#include <cmath>  

#include <stdlib.h> 
#include <iomanip>
#include "kinematics.h"

using namespace std;


int main() {

//	cout << "Is this working? " << endl;

//	cout << ""


//	Q1p6_low_eps[] = {1,2,3};
	
// Phi angle definition
	phix = 0;

	printf("*--------------------------------------------------*/\n");
	printf("* omega meson mass: 0.78265 GeV \n");
	printf("* phi meson mass: 1.019461 GeV \n");
	printf("*--------------------------------------------------*/\n");

	printf(" Enter meson mass, Q^2, W in GeV\n");

	cin >>  m_meson_g >>  q_2_g >> W_g;
	cout << m_meson_g <<  "  " << q_2_g << "  " << W_g <<endl;


	//p_proton_lab = 2931;

// 	if (q_2_g == float(1.6)) {
// 		p_proton_lab = 2931;
// 	} else if (q_2_g==float(2.45)) {
// 		p_proton_lab = 3336;
// 	}

	
	m_meson = m_meson_g * 1000.;
	W = W_g * 1000.;
	q_2 = q_2_g * 1000.;


		
	// Calculate the energy of the virtual photon (reference to Henk's HUG notes)
	nu_g = (pow(W_g,2) + q_2_g - pow(m_p_g,2) ) / (2 * m_p_g);
	nu = nu_g * 1000.; 
	// Momentum of virtual photon

	p_gamma_g = sqrt( pow(nu_g,2) + q_2_g);
	p_gamma   = p_gamma_g * 1000.;


	// Speed of the virtual photon+proton in CM frame

	beta_cm = p_gamma / (nu + m_p);
	gamma_cm = (nu + m_p) / W; 
	


	// Proton-Pion system momentum in CM frame
	p_cm = sqrt( pow((pow(W,2) + pow(m_meson,2) - pow(m_p,2)), 2) - 4. * pow((W*m_meson), 2) ) / (2.* W);
	
	// meson energy
    e_meson_cm = sqrt(pow(p_cm,2) + pow(m_meson,2) );

	// Proton energy
    e_proton_cm = sqrt(pow(p_cm,2) + pow(m_p,2) );
	

	//for(unsigned int i=0; i < beam_energy.size(); i++) {
	//


	

	int size=sizeof beam_energy/sizeof(int);

	for(unsigned int i=0; i < size; i++) {

		//cout << beam_energy[i] << endl;
		
		// Incoming electron beam kinetic energy, total energy and momentum

		t_in = beam_energy[i];
		t_in_g = t_in / 1000.;

		e_in = t_in + m_e;
		e_in_g = e_in / 1000.;		

		p_in = sqrt(pow(e_in, 2) - pow(m_e, 2));
		p_inz = p_in;
		p_inx = 0;


		// Scattering energy and momentum
		e_scat = e_in - nu;
		e_scat_g = e_scat / 1000.;
		
	    cout <<  "Electron scattering energy: " << e_scat << endl;
 		
    	if (e_scat < m_e) { 
			cerr << "Scattering energy is less than electron mass!" << endl 
				 << "Program ends!" << endl;
			continue;
		}
		t_scat = e_scat - m_e;
		t_scat_g = t_scat / 1000.;
		
		p_scat = sqrt( pow(e_scat,2) + pow(m_e,2));




		
		angle = ( pow(p_in, 2) + pow(p_scat, 2) - pow(p_gamma, 2) ) /(2. * p_in * p_scat);

// 		if (abs(angle) < 1) {
// 			cout << "Is this working? " << endl;
// 		}

		// SOS angle
		theta_angle = acos(angle);

// 		cout << "/*--------------------------------------------------*/" << endl;
// 		cout << "Angle Check: " << angle << "       " << Rad_to_Deg(theta_angle) << endl;
// 		cout << "/*--------------------------------------------------*/" << endl;

		p_scatz = p_scat * cos(theta_angle);
		p_scatx = p_scat * sin(theta_angle);

		// Virtual photon polarization
		epsilon = 1./ (1.+ 2.*pow(p_gamma_g,2)/q_2_g * pow((tan(theta_angle/2.)),2));

// 		cout << "/*--------------------------------------------------*/" << endl;
// 		cout << "epsilon: " << p_scatx << "      "<< p_scatz << "       " << epsilon << endl;
// 		cout << "/*--------------------------------------------------*/" << endl;

		p_gammaz = p_inz - p_scatz;
		p_gammax = p_inx - p_scatx;
		p_gammay = 0.;

		p_gamma_temp = sqrt(pow(p_gammax,2) + pow(p_gammay,2) + pow(p_gammaz,2));

		theta_gamma = atan(p_gammax/p_gammaz);


// 		cout << "/*--------------------------------------------------*/" << endl;
// 		cout << "gamma: " << p_gammaz << "      "<< p_gammax << "       " 
// 			 << Rad_to_Deg(theta_gamma) << endl;
// 		cout << "/*--------------------------------------------------*/" << endl;
// 
// 
// 		cout << "AAAAAAA theta_gamma recheck: " <<  p_gammax << "   " << p_gammaz << 
// 		"   " << Rad_to_Deg(theta_gamma) << endl;



		change_beam_e = true;

// 		for(ithpq_lab=0; ithpq_lab <= 30; ithpq_lab=ithpq_lab+2) {
// 
// 
// 
// 			thpq_lab = ithpq_lab;
// 
// 			// HMS angle
// 			thp_lab = -(abs(theta_gamma) + cos(Deg_to_Rad(phix))*thpq_lab);
// 
// 			//cout << ithpq_lab << endl;
// 
// 			// find cm angle of proton
// 			a = pow((tan(Deg_to_Rad(thpq_lab))*gamma_cm*p_cm), 2) + pow(p_cm, 2);
// 			b = 2.* p_cm * e_proton_cm * beta_cm * pow(tan(Deg_to_Rad(thpq_lab))*gamma_cm,2);
// 			c = pow((tan(Deg_to_Rad(thpq_lab)) * gamma_cm * beta_cm * e_proton_cm), 2) -pow(p_cm, 2);
// 
// 
// 
// 			// cout << "Variable check: "<< a << "      " << b << "      "<< c << endl;
// 			// cout << thpq_lab << "   " << pow(b,2) - 4.*a*c  << endl;
// 
// 			if (pow(b,2) - 4.*a*c < 0) {
// 				cout << "b^2-4*a*c value is less than 0! " << endl 
// 					 << "For loop breaks! " << endl;
// 				break;
// 
// 			}
// 
// 
// 			cos_thp = (-b + sqrt(pow(b,2) -4.*a*c )) / (2.*a);
// 
// 			if (abs(cos_thp) <= 1) {
// 				//Radian
// 				thp_cm =acos(cos_thp);
// 			} else {
// 				cerr << "Cos of the proton angle is larger than 1 ! " << endl
// 					 << "Program end! " << endl;
// // 				exit(0);
// 				break;
// 			}
// 
// 			//cout << "thp_cm   " << cos_thp << "      "<< Rad_to_Deg(thp_cm) << endl;
// 
// 			//cout  << "gamma " << gamma_cm << "   " << p_cm << "   " << beta_cm << endl;
// 
// 			p_proton_lab = gamma_cm * (p_cm * cos(thp_cm) + beta_cm * e_proton_cm)/cos(Deg_to_Rad(thpq_lab));		
// 			e_proton = sqrt(pow(p_proton_lab,2) + pow(m_p,2));
// 
// 			//cout  << "Proton Energy and momentum check: " << p_proton_lab << "       " << e_proton << endl;
// 
// 
// 			theta_meson_cm = 180. - Rad_to_Deg(thp_cm);
// 			
// 			tan_theta_messon = p_cm*sin(Deg_to_Rad(theta_meson_cm)) / (gamma_cm * 
// 				(beta_cm * e_meson_cm - p_cm * cos(thp_cm)));
// 			
// 			thmq_lab = atan(tan_theta_messon);
// 
// 
// 			//cout << "Meson angle check: "<< theta_meson_cm << "     " << Rad_to_Deg(thmq_lab) << endl;
// 
// 
// 			p_meson_lab = gamma_cm * (p_cm * cos(Deg_to_Rad(theta_meson_cm)) + beta_cm*e_meson_cm) / 
// 				cos(thmq_lab);
//  
// 			p_meson_lab_g = p_meson_lab/1000.;
// 
// 			e_meson = sqrt(pow(p_meson_lab,2) + pow(m_meson,2));
// 
// 			t = 2. * m_p*(m_p-e_proton);
// 			
// 			t_g = t/1.e6;
// 
// 			u = pow((m_p - e_meson), 2) - pow(p_meson_lab, 2);
// 			u_g = u/1.e6;
// 
// 
// 
// 		    //cout << "Pion energy and momentum check: "<< p_meson_lab << "         " << e_meson << endl;
// 
// 		    //cout << "Check u and t " << u_g <<  "       " << t_g  << endl;
// 
// 
// 			// Rotate to the lab frame wrt e- beam
// 			p_px    = p_proton_lab*(cos(Deg_to_Rad(thpq_lab))*sin(theta_gamma) - sin(Deg_to_Rad(thpq_lab))*
// 					  cos(theta_gamma)*cos(Deg_to_Rad(phix)));
// 
// 			p_py    = p_proton_lab*sin(Deg_to_Rad(thpq_lab))*sin(Deg_to_Rad(phix));
// 
// 
// 			p_pz    = p_proton_lab*(cos(Deg_to_Rad(thpq_lab))*cos(theta_gamma) + sin(Deg_to_Rad(thpq_lab))*
// 					  sin(theta_gamma)*cos(Deg_to_Rad(phix)));
// 
// 			p_ptemp = sqrt( pow(p_px,2) + pow(p_py,2) + pow(p_pz,2) );
// 
// 
// 
// 			//cout << "Pz check: " << p_proton_lab << "   "<< thpq_lab << "   " << Rad_to_Deg(theta_gamma)
// 			//	 << "   "<< phix << endl;
// 
// 			//cout << "Momentum Check: " << p_px << "   "<< p_py << "   " << p_pz << "   "<< p_ptemp << endl;
// 
// 
// 
// 			// HMS angle
// 			thp = -acos(p_pz/p_proton_lab);
// 
// 			vertp = asin(p_py/p_proton_lab);
// 
// 			x = q_2_g/(2.* m_p_g * nu_g);
// 
// 			z = e_proton/nu;
// 
// 
// 			//cout << "Final check: " << Rad_to_Deg(thp) << "  " << Rad_to_Deg(vertp) << "  " << x << "  " << z << endl; 
// 
// 
// 
// 
// 
// 			// Header
// 			if(change_beam_e) {
// 
// 				//cout << beam_energy[i] << endl; 
// 
// 				cout << "            p(e,e*p)meson kinematics for Q^2 = " << q_2_g << " GeV^2" << "    W = " << W_g
// 					 << " GeV    " << endl 
// 					 << "               nu = omega = " << nu << "MeV    Pgamma = " << p_gamma << " MeV/c     " 
// 					 << endl << "                   Meson Mass = " << m_meson << " MeV    " << "Phi = " << phix 
// 					 << endl;
// 				
// 
// 
// 
// 
// 				cout  << "  Tinc       Te*      THe*    epsilon       -t     "
// 					  << "THq     Pp       THpq     Pm        Thmq    -u         x " <<endl
// 					  << "  MeV        MeV      deg                  GeV/c   "
// 					  << "deg    MeV/c     deg     MeV/c       deg   GeV/c2 "<< endl; 
// 
// 				change_beam_e = false;
// 			}
// 
// 	    //tinc,tscat,thscat,epsilon,-tg,thgam,pplab,thpqlab,pmlab,thmqlab,-ug,x
// 
// 
// 
// 		cout << setprecision(7) << setw(8) << t_in << " "<< setw(9)   << t_scat  <<  "   " << setw(6) 
// 			 << setprecision(5) << Rad_to_Deg(theta_angle) << setprecision(4) 
// 			 << setw(5) << " " << epsilon << "  "<< fixed << setprecision(3) << setw(9) << -t_g  << " " << setw(8) 
// 			 << Rad_to_Deg(theta_gamma) << "  " 			<< setprecision(3)   << p_proton_lab; 
// 			
// 
// 
// 		cout << " " <<  setprecision(1) << setw(4) << thpq_lab 
// 			 << " " << setprecision(2) << setw(10) << p_meson_lab << " "<< setprecision(4) 
// 			 << setw(8) << fixed << Rad_to_Deg(thmq_lab); 
// 
// 			 cout.unsetf(ios_base::floatfield);
// 
// 			 cout << " " << fixed << setprecision(4) << setw(7)<< -u_g << "    " << setprecision(4)<< setw(7)<< x << endl;
// 			 cout.unsetf(ios_base::floatfield);
// 
// 			
// 			
// 		}
// 
// 

/*--------------------------------------------------*/
/*--------------------------------------------------*/
/*--------------------------------------------------*/
/*--------------------------------------------------*/


		cout << "-----------------------------"<< endl;
		test_out(theqp_Q1p6_low_eps, sizeof(theqp_Q1p6_low_eps)/sizeof(float));

		cout << "-----------------------------"<< endl;

		test_out(theqp_Q1p6_high_eps, sizeof(theqp_Q1p6_high_eps)/sizeof(float));

		cout << "-----------------------------"<< endl;

		test_out(theqp_Q2p45_low_eps, sizeof(theqp_Q2p45_low_eps)/sizeof(float));

		cout << "-----------------------------"<< endl;

		test_out(theqp_Q2p45_high_eps, sizeof(theqp_Q2p45_high_eps)/sizeof(float));

		cout << "-----------------------------"<< endl;

	}


// Formated	output to the screen
//   const char * format = "%.1f \t%.1f \t%.1f \t%.1f \t%.1f\n";
//   printf ("value\tround\tfloor\tceil\ttrunc\n");
//   printf ("-----\t-----\t-----\t----\t-----\n");
//   printf (format, 2.3,round( 2.3),floor( 2.3),ceil( 2.3),trunc( 2.3));
//   printf (format, 3.8,round( 3.8),floor( 3.8),ceil( 3.8),trunc( 3.8));
//   printf (format, 5.5,round( 5.5),floor( 5.5),ceil( 5.5),trunc( 5.5));
//   printf (format,-2.3,round(-2.3),floor(-2.3),ceil(-2.3),trunc(-2.3));
//   printf (format,-3.8,round(-3.8),floor(-3.8),ceil(-3.8),trunc(-3.8));
//   printf (format,-5.5,round(-5.5),floor(-5.5),ceil(-5.5),trunc(-5.5));



  return 0;
}



void test_out(float array[], int limit) {


//		int thqp_size= array /sizeof(int);

		int thqp_size= limit;

//		cout << "OOOOOOOOOOOOOOOOOO " << thqp_size << endl

		for(int ii=0; ii < thqp_size; ii++) {

			thpq_lab = array[ii] - Rad_to_Deg(theta_gamma);

//			cout << ii << "  " <<  theqp_Q1p6_low_eps[ii] << "  AAAAAAAAA " <<  theqp_Q1p6_low_eps[ii] << "     "
//				 << Rad_to_Deg(theta_gamma) << "   " << thpq_lab << endl;


			// HMS angle
			thp_lab = -(abs(theta_gamma) + cos(Deg_to_Rad(phix))*thpq_lab);

			//cout << ithpq_lab << endl;

			// find cm angle of proton
			a = pow((tan(Deg_to_Rad(thpq_lab))*gamma_cm*p_cm), 2) + pow(p_cm, 2);
			b = 2.* p_cm * e_proton_cm * beta_cm * pow(tan(Deg_to_Rad(thpq_lab))*gamma_cm,2);
			c = pow((tan(Deg_to_Rad(thpq_lab)) * gamma_cm * beta_cm * e_proton_cm), 2) -pow(p_cm, 2);



			// cout << "Variable check: "<< a << "      " << b << "      "<< c << endl;
			// cout << thpq_lab << "   " << pow(b,2) - 4.*a*c  << endl;

			if (pow(b,2) - 4.*a*c < 0) {
				cout << "b^2-4*a*c value is less than 0! " << endl 
					 << "For loop breaks! " << endl;
				break;

			}


			cos_thp = (-b + sqrt(pow(b,2) -4.*a*c )) / (2.*a);

			if (abs(cos_thp) <= 1) {
				//Radian
				thp_cm =acos(cos_thp);
			} else {
				cerr << "Cos of the proton angle is larger than 1 ! " << endl
					 << "Program end! " << endl;
// 				exit(0);
				break;
			}

			//cout << "thp_cm   " << cos_thp << "      "<< Rad_to_Deg(thp_cm) << endl;

			//cout  << "gamma " << gamma_cm << "   " << p_cm << "   " << beta_cm << endl;

			Cal_print();

	}
}








void Cal_print(){  


//			cout << "     sssssssssss     "<< q_2_g << endl;

			
			if (q_2_g == float(1.6)) {
				p_proton_lab = 2931;
			} else if (q_2_g == float(2.45)) {
				p_proton_lab = 3336;
			} else {			
				p_proton_lab = gamma_cm * (p_cm * cos(thp_cm) + beta_cm * e_proton_cm)/cos(Deg_to_Rad(thpq_lab));
			}


//			p_proton_lab = gamma_cm * (p_cm * cos(thp_cm) + beta_cm * e_proton_cm)/cos(Deg_to_Rad(thpq_lab));



// 			p_proton_lab = gamma_cm * (p_cm * cos(thp_cm) + beta_cm * e_proton_cm)/cos(Deg_to_Rad(thpq_lab));		
		
			e_proton = sqrt(pow(p_proton_lab,2) + pow(m_p,2));

			//cout  << "Proton Energy and momentum check: " << p_proton_lab << "       " << e_proton << endl;


			theta_meson_cm = 180. - Rad_to_Deg(thp_cm);
			
			tan_theta_messon = p_cm*sin(Deg_to_Rad(theta_meson_cm)) / (gamma_cm * 
				(beta_cm * e_meson_cm - p_cm * cos(thp_cm)));
			
			thmq_lab = atan(tan_theta_messon);


			//cout << "Meson angle check: "<< theta_meson_cm << "     " << Rad_to_Deg(thmq_lab) << endl;


			p_meson_lab = gamma_cm * (p_cm * cos(Deg_to_Rad(theta_meson_cm)) + beta_cm*e_meson_cm) / 
				cos(thmq_lab);
 
			p_meson_lab_g = p_meson_lab/1000.;

			e_meson = sqrt(pow(p_meson_lab,2) + pow(m_meson,2));

			t = 2. * m_p*(m_p-e_proton);
			
			t_g = t/1.e6;

			u = pow((m_p - e_meson), 2) - pow(p_meson_lab, 2);
			u_g = u/1.e6;



		    //cout << "Pion energy and momentum check: "<< p_meson_lab << "         " << e_meson << endl;

		    //cout << "Check u and t " << u_g <<  "       " << t_g  << endl;


			// Rotate to the lab frame wrt e- beam
			p_px    = p_proton_lab*(cos(Deg_to_Rad(thpq_lab))*sin(theta_gamma) - sin(Deg_to_Rad(thpq_lab))*
					  cos(theta_gamma)*cos(Deg_to_Rad(phix)));

			p_py    = p_proton_lab*sin(Deg_to_Rad(thpq_lab))*sin(Deg_to_Rad(phix));


			p_pz    = p_proton_lab*(cos(Deg_to_Rad(thpq_lab))*cos(theta_gamma) + sin(Deg_to_Rad(thpq_lab))*
					  sin(theta_gamma)*cos(Deg_to_Rad(phix)));

			p_ptemp = sqrt( pow(p_px,2) + pow(p_py,2) + pow(p_pz,2) );



			//cout << "Pz check: " << p_proton_lab << "   "<< thpq_lab << "   " << Rad_to_Deg(theta_gamma)
			//	 << "   "<< phix << endl;

			//cout << "Momentum Check: " << p_px << "   "<< p_py << "   " << p_pz << "   "<< p_ptemp << endl;



			// HMS angle
			thp = -acos(p_pz/p_proton_lab);

			vertp = asin(p_py/p_proton_lab);

			x = q_2_g/(2.* m_p_g * nu_g);

			z = e_proton/nu;


			//cout << "Final check: " << Rad_to_Deg(thp) << "  " << Rad_to_Deg(vertp) << "  " << x << "  " << z << endl; 





			// Header
			if(change_beam_e) {

				//cout << beam_energy[i] << endl; 

				cout << "            p(e,e*p)meson kinematics for Q^2 = " << q_2_g << " GeV^2" << "    W = " << W_g
					 << " GeV    " << endl 
					 << "               nu = omega = " << nu << "MeV    Pgamma = " << p_gamma << " MeV/c     " 
					 << endl << "                   Meson Mass = " << m_meson << " MeV    " << "Phi = " << phix 
					 << endl;
				




				cout  << "  Tinc       Te*      THe*    epsilon       -t     "
					  << "THq     Pp       THpq     Pm        Thmq    -u         x " <<endl
					  << "  MeV        MeV      deg                  GeV/c   "
					  << "deg    MeV/c     deg     MeV/c       deg   GeV/c2 "<< endl; 

				change_beam_e = false;
			}

	    //tinc,tscat,thscat,epsilon,-tg,thgam,pplab,thpqlab,pmlab,thmqlab,-ug,x



		cout << setprecision(7) << setw(8) << t_in << " "<< setw(9)   << t_scat  <<  "   " << setw(6) 
			 << setprecision(5) << Rad_to_Deg(theta_angle) << setprecision(4) 
			 << setw(5) << " " << epsilon << "  "<< fixed << setprecision(3) << setw(9) << -t_g  << " " << setw(8) 
			 << Rad_to_Deg(theta_gamma) << "  " 			<< setprecision(3)   << p_proton_lab; 
			


		cout << " " <<  setprecision(1) << setw(4) << thpq_lab 
			 << " " << setprecision(2) << setw(10) << p_meson_lab << " "<< setprecision(4) 
			 << setw(8) << fixed << Rad_to_Deg(thmq_lab); 

			 cout.unsetf(ios_base::floatfield);

			 cout << " " << fixed << setprecision(4) << setw(7)<< -u_g << "    " << setprecision(4)<< setw(7)<< x << endl;
			 cout.unsetf(ios_base::floatfield);
			
}


